package example.energy;

import schedframe.resources.computing.ComputingResource;
import schedframe.resources.computing.profiles.energy.ResourceEvent;
import schedframe.resources.devices.PhysicalResource;
import schedframe.scheduling.manager.tasks.JobRegistry;


public class DefaultEnergyEstimationPlugin extends BaseEnergyEstimationPlugin{


	public double estimatePowerConsumption(ResourceEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
		double powerConsumption = 0;
		try {
			powerConsumption = resource.getPowerInterface().getPowerConsumption(resource.getPowerInterface().getPowerState());
		} catch (NoSuchFieldException e) {
			powerConsumption = 0;
		}
		
		ComputingResource cr = (ComputingResource) resource;
		powerConsumption = powerConsumption + getChildrenPowerConsumption(cr);

		return powerConsumption;
	}
	
	private double getChildrenPowerConsumption(ComputingResource resource){
		double powerConsumption = 0;
		for(ComputingResource child:resource.getChildren()){
			try {
				powerConsumption = powerConsumption + child.getPowerInterface().getRecentPowerUsage().getValue(); 
			} catch (Exception e) {
				powerConsumption = powerConsumption + getChildrenPowerConsumption(child);
			}
		}
		return powerConsumption;
	}
}
