package example.energy.coolemall;

import schedframe.resources.StandardResourceType;
import schedframe.resources.computing.ComputingResource;
import schedframe.resources.computing.coolemall.ComputeBox1;
import schedframe.resources.computing.coolemall.NodeGroup;
import schedframe.resources.computing.profiles.energy.ResourceEvent;
import schedframe.resources.devices.Device;
import schedframe.resources.devices.Fan;
import schedframe.resources.devices.PhysicalResource;
import schedframe.scheduling.manager.tasks.JobRegistry;
import simulator.ConfigurationOptions;
import example.energy.BaseEnergyEstimationPlugin;

public class FlowPumpOutletEnergyEstimationPlugin extends BaseEnergyEstimationPlugin {

	public double estimatePowerConsumption(ResourceEvent event, JobRegistry jobRegistry,
			PhysicalResource resource) {
		
		double powerConsumption = 0;

		return powerConsumption;
	}
	
	public double estimateAirflow(ResourceEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
		double airflow = 0;
		double Vair_total;
		
		Vair_total = ConfigurationOptions.coolingData.getAirflowVolume();
		if(Vair_total != -1) {
			airflow = Vair_total;
		} else {
			Device flowPump = (Device) resource;
			ComputingResource room = flowPump.getComputingResource();

			double ro = 1.168;//constant
			
			double mair_total;
			double mair_rack = 0;

			for(ComputingResource cr: room.getChildren()){
				ComputeBox1 cb1 = (ComputeBox1)cr;
				for(NodeGroup nodeGroup: cb1.getNodesGroups()){
					for(Device device: nodeGroup.getResourceCharacteristic().getDevices()){
						if(device.getType().equals(StandardResourceType.Outlet)){
							
							Fan fan = (Fan) device;
							double mair_recs = 0;
							double Vair_recs = 0;
							
							double Vair_recs1 = 0;

							Vair_recs1  = fan.getAirflowInterface().getRecentAirflow().getValue();

							double Vair_recs2 = 0;
							for(Device device2: nodeGroup.getResourceCharacteristic().getDevices()){
								if(device2.getType().equals(StandardResourceType.Inlet) && device2.getFullName().equals(fan.getFullName().replace("Outlet", "Inlet"))){

									Vair_recs2  = device2.getAirflowInterface().getRecentAirflow().getValue();

									break;
								}
							}	

							Vair_recs  = Math.max(Vair_recs1, Vair_recs2);

							mair_recs = Vair_recs * ro;
							mair_rack  = mair_rack + mair_recs;
						}
					}
				}
			}
			mair_total = mair_rack;
			Vair_total = mair_total / ro;
			airflow = Vair_total;
		}
		return airflow;
	}
}
